
-- create reader and writer role
declare
    role_exists exception;
    PRAGMA EXCEPTION_INIT(role_exists,-1921);
    readerRole VARCHAR2(30);
    writerRole VARCHAR2(30);
begin
    readerRole:='r_fwConfR_'||USER;
    writerRole:='r_fwConfW_'||USER;
	execute immediate 'CREATE ROLE '||readerRole;
	execute immediate 'GRANT SELECT  ON HIERARCHIES            TO '||readerRole;
	execute immediate 'GRANT SELECT  ON DEVICE_TYPES           TO '||readerRole;
	execute immediate 'GRANT SELECT  ON ITEMS                  TO '||readerRole;
	execute immediate 'GRANT SELECT  ON RECIPES                TO '||readerRole;
	execute immediate 'GRANT SELECT  ON RECIPE_VERSIONS        TO '||readerRole;
	execute immediate 'GRANT SELECT  ON RECIPE_DATA            TO '||readerRole;
	execute immediate 'GRANT SELECT  ON RECIPE_TAGS            TO '||readerRole;
	execute immediate 'GRANT SELECT  ON DEVICE_ELEMENTS        TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_ITEMS_NEW       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_ITEMPROPS       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_DESC            TO '||readerRole;
	execute immediate 'GRANT SELECT  ON REFERENCES             TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_VALUES          TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_VALUES_BIG      TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_ADDRESSES       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_ALERTS          TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_DPEALERTS       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_SUMALERTS       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_ALERTS_MISC     TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_ARCHIVING       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_DPFUNCTIONS     TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_CONVERSIONS     TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_PVRANGES        TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_SMOOTHING       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_UF              TO '||readerRole;
	execute immediate 'GRANT SELECT  ON CONFIG_GENERAL         TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_RECIPESALL           TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_REFERENCES           TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_CONFIG_ITEMS         TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_DEVICE_CONFIGS       TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_DEVICE_CONFIGS_ALL   TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_ITEM_PROPERTIES      TO '||readerRole;
	execute immediate 'GRANT SELECT  ON V_CONFIG_ALERTS        TO '||readerRole;
	execute immediate 'GRANT ALL     ON CDB_API_PARAMS         TO '||readerRole;
	execute immediate 'GRANT ALL     ON TMP_ITEM_PROPS         TO '||readerRole;
	execute immediate 'GRANT EXECUTE ON fwConfigurationDB      TO '||readerRole;
	execute immediate 'GRANT EXECUTE ON lstAgg                 TO '||readerRole;
	execute immediate 'GRANT EXECUTE ON lstAggNum              TO '||readerRole;

	execute immediate 'CREATE ROLE '||writerRole;
	execute immediate 'GRANT '||readerRole||'                                TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON HIERARCHIES            TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON DEVICE_TYPES           TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON ITEMS                  TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE,DELETE  ON RECIPES                TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE,DELETE  ON RECIPE_VERSIONS        TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE,DELETE  ON RECIPE_DATA            TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE,DELETE  ON RECIPE_TAGS            TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON DEVICE_ELEMENTS        TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_ITEMS_NEW       TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_ITEMPROPS      TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_DESC            TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON REFERENCES             TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_VALUES          TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_VALUES_BIG      TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_ADDRESSES       TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_ALERTS          TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_DPEALERTS       TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_SUMALERTS       TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_ALERTS_MISC     TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_ARCHIVING       TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_DPFUNCTIONS     TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_CONVERSIONS     TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_PVRANGES        TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_SMOOTHING       TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_UF              TO '||writerRole;
	execute immediate 'GRANT INSERT,UPDATE         ON CONFIG_GENERAL         TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON CITEM_ID_SEQ           TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON CONF_ID_SEQ            TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON DEVELEM_ID_SEQ         TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON DPT_ID_SEQ             TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON IPROP_ID_SEQ           TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON ITEMS_ID_SEQ           TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON RECIPES_RVER_SEQ       TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON RECIPES_TAGID_SEQ      TO '||writerRole;
	execute immediate 'GRANT SELECT  		ON RECIPE_DATA_PROPID_SEQ TO '||writerRole;


exception
    when role_exists then
	null; -- we simply accept it 
end;
/
