
/*
Modification History:
  - 14/09/2011: Herve
  IS-595: MAIL/SMS: automatic send email at startup is now configurable, by default if no entry ==> no mail at startup
  
  05/09/2011: Herve
  - IS-598: system name and component version added in the MessageText log and in the diagnostic  
  
  28/06/2011: Herve
  - IS-553: periodic report based on a user defined function

  21/03/20009: Herve
  - in the function _unSendMail_Settings_CallBack, clear all the global dyn_string
  
	25/03/2009: Frederic
	- unSendMail_Init() - fix bug Lines 875 and 314 - Replace len=dynlen(g_dsDpe); BY len=dynlen(g_dsType);
	16/02/2009: Frederic
    - update _unSendMail_Settings_CallBack() - init g_diToday mapping variable (when a new Category is dynamically created)
	02/12/2008: Frederic
		- solve the problem with the Max number of Mails per day
	24/04/2008: Frederic
		- Max number of Mails per category and not per receiver + some improvements (Multi receivers in one message, Lemon, ...)
	19/02/2008: Herve
		- check if component isntalled before getting info on it
	26/07/2007: Herve
		_unSendMail_Report_CallBack, unSendMail_Init: use %x in formatTime  --> Frederic: set formatTime("%m/%d/%Y  %H:%M:%S", tTime);
	20/07/2007 Frederic:
		.add functions:	_unSendMail_getText() and _unSendMail_getTitle() => common format for the messages
	20/06/2006 Celine:
		.add backup in the report : bad (not launched or not correctly executed) or ok
	10/04/2006 Celine:
		.add last backup time in Report	
	05/12/2005 Celine:
	 	.main, _unSendMail_Message_CallBack : add a mail counter (max 250 mails per day) to avoid sending too much mail in one day.
	13/06/2005 Celine:
		. add SMS : when address mail is with "4176487*mail2sms.cern.ch"
	09/08/2004 Frederic:
		. in _unSendMail_Report_CallBack function: add "Disable" text, new main text and title format
		. in _unSendMail_Message_CallBack function: modifications to get receivers from report list
		. create function: _unSendMail_Message() = send each email
		. in _unSendMail_Report_CallBack function: call _unSendMail_Message() to send message instead of dpSet...
*/

//@{

// global declaration
dyn_string g_unSendMail_ConnectList; 		//list of dp checked
dyn_string g_dsSender;						      //Mail address for the Sender
dyn_string g_dsType;						        //Type of Alarm
dyn_bool g_dbMax;							          //Max number of Emails reached
dyn_string g_dsReceiver;					      //Mail address(es) for the Receiver
dyn_string g_dsSmtp;        						//smtp server
dyn_string g_dsDomain;			      			//Domain name
dyn_string g_dsLink;						        //Link name (lemon for ex)
dyn_string g_dsMax;							        //max number of mails per day and per receiver(=mailbox)
dyn_string g_dsDpe;							        //Report Dpe list
dyn_bool g_dbDisable;						        //True = Disable Sending Mails
mapping g_diDayCounter; 					      //number of mail sent per category and per day
mapping g_diToday; 								      //day number per category
string g_sVersion;							        //unicosObject component version
const string c_LemonLink = "http://abinf1/lemon/info.php?host=";
global string g_Mail_sSystemName;

// const
const int SETTINGSMAIL_PATTERN=1;
const int NEWMAIL_PATTERN=2;
const int REPORT=3;

const string SEPARATOR="~";					//Separator for the several field in Setting Dp
const string DELEMITER=";";					//Separaror for the Receivers
const string SMS_PATTERN = "*@mail2sms.cern.ch";
const int TYPE=1;
const int DOMAIN=2;
const int SMTP=3;
const int SENDER=4;
const int RECEIVER=5;
const int LINK=6;
const int MAX=7;

const int DPE=1;
const int TIME=2;
const int ALERT_TEXT=3;
const int VALUE=4;
const int DESC = 4;

const int DELAY_RESEND=60;
const int DELAY_INIT=5;

const int c_iMaxMailPerDay = 250; 		//number of max mails per day
const string c_DPE_Backup = "_unApplication.unBackupStatus";

// main
/**
Purpose:
This is the main of the script.

Usage: Public

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. no temporary data point, no graphical element
	. PVSS version: 3.1 
	. operating system: XP, SLC4
	. distributed system: no / must work in local
*/

main()
{
string sDp_1, sDp_2;
dyn_bool dbDisable;
dyn_string dsSettings, exceptionInfo, dpToCheck, dsVersion, dsReport;
int iRes, len_1, len_2;
dyn_dyn_string ddsComponents;
int i, len;
  string sMessage;

  g_Mail_sSystemName = getSystemName();
  
  fwInstallation_getInstalledComponents(ddsComponents);
  len = dynlen(ddsComponents);
  for(i=1;i<=len;i++)
    {
    if(ddsComponents[i][1] == "unicosObjects")
      {
  	  iRes = fwInstallation_getComponentInfo ("unicosObjects", "componentversion", dsVersion);
  	   if (dynlen(dsVersion)>0)
  		  g_sVersion=dsVersion[1];
       }
     }
  
	sDp_1="_unSendMail.config";
	sDp_2="_unSendMail.message";
	
	delay(DELAY_INIT);
	
	if (dpExists(sDp_1) && dpExists(sDp_2))
  	{
  	iRes=dpGet(sDp_1 + ".mail_settings", dsSettings, sDp_1 + ".mail_disable", dbDisable, sDp_1 + ".report_settings", dsReport);
  	len_1=dynlen(dsSettings);
  	len_2=dynlen(dsSettings);
	
  	if ((len_1>0) && (len_2==len_1) && (iRes>=0))
  		{
		if(dynlen(dsReport)!=len_1)	//check coherency and adjust if needed
			{
			while(dynlen(dsReport)<len_1)
				{
				dynAppend(dsReport, "");
				}	
			while(dynlen(dsReport)>len_1)
				{
				dynRemove(dsReport, dynlen(dsReport));
				}
			dpSetWait(sDp_1 + ".report_settings", dsReport);
			fwException_raise(exceptionInfo, "EXPERTINFO", "_unSendMail.report_settings dpe automatically updated - dynlen size was not correct!","");			
			}
		
  		dynClear(dpToCheck);
  		//Settings
  		dpToCheck[1]=sDp_1 + ".mail_settings";
  		dpToCheck[2]=sDp_1 + ".mail_disable";
  		dpToCheck[3]=sDp_1 + ".report_settings";
  		_unSendMail_set_checking(dpToCheck, SETTINGSMAIL_PATTERN, exceptionInfo);		
		
  		unSendMail_Init();
				
  		//New Message
  		dynClear(dpToCheck);
  		dpToCheck[1]=sDp_2 + ".mail_text";
  		_unSendMail_set_checking(dpToCheck, NEWMAIL_PATTERN, exceptionInfo);		
		
  		//Periodic Report
  		dynClear(dpToCheck);
  		dpToCheck[1]=sDp_2 + ".periodic_report";
  		_unSendMail_set_checking(dpToCheck, REPORT, exceptionInfo);		
  		}
  	else		//if ((dynlen(dsSettings)<=0) && (iRes<0))
  		fwException_raise(exceptionInfo, "ERROR", "main(): "+getCatStr("unSendMail", "CANNOT_GET_SETTINGS") + sDp_1,"");	
  	}
  else			//if (dpExists(sDp))
	  fwException_raise(exceptionInfo, "ERROR", "main(): "+getCatStr("unSendMail", "DP_DOESNT_EXIST") + sDp_1 + " or " + sDp_2,"");	

  sMessage = unGenericDpFunctions_getComponentsVersion(makeDynString("unSystemIntegrity", "unCore"));
  if(isFunctionDefined("unMessageText_sendException"))
    unMessageText_send("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", "INFO", "SendMail "+sMessage+" loaded", exceptionInfo);
  else
    DebugTN(g_Mail_sSystemName+"SendMail", "SendMail "+sMessage+" loaded");
    
  if(dynlen(exceptionInfo) > 0) 
  	{
  	if(isFunctionDefined("unMessageText_sendException"))
  		unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
  	}
}

// _unSendMail_set_checking
/**
Purpose:
This function register/de-register the callback funtion of SendMail.

	@param dsCallBackParam: dyn_string, input, data point names
	@param iPattern: int, input, Pattern to know action
	@param exceptionInfo: dyn_string, output, exception are returned here

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

_unSendMail_set_checking(dyn_string dsCallBackParam, int iPattern, dyn_string &exceptionInfo)
{
int iRes, len;
len=dynlen(dsCallBackParam);

if ((len==3 && iPattern==SETTINGSMAIL_PATTERN) || (len==1 && iPattern==NEWMAIL_PATTERN) || (len==1 && iPattern==REPORT))
	{
	switch(iPattern)
		{
		case SETTINGSMAIL_PATTERN:
			// connect to the callback function if not already done
			iRes=dynContains(g_unSendMail_ConnectList,"_unSendMail_Settings_CallBack");
			if(iRes <= 0)
				{
				iRes = dpConnect("_unSendMail_Settings_CallBack", dsCallBackParam[1], dsCallBackParam[2], dsCallBackParam[3]);
						
				if(iRes < 0)
					{
					fwException_raise(exceptionInfo, "ERROR", "_unSendMail_set_checking(): "+getCatStr("unSendMail", "CANNOT_DP_CONNECT") + " _unSendMail_Settings_CallBack","");
					}
				else
					{
					dynAppend(g_unSendMail_ConnectList,"_unSendMail_CallBack");
					}
				}
			break;
	
		case NEWMAIL_PATTERN:
			// connect to the callback function if not already done
			iRes=dynContains(g_unSendMail_ConnectList,"_unSendMail_Message_CallBack");
			if(iRes <= 0)
				{
				iRes = dpConnect("_unSendMail_Message_CallBack", false, dsCallBackParam[1]);
						
				if(iRes < 0)
					{
					fwException_raise(exceptionInfo, "ERROR", "_unSendMail_set_checking(): "+getCatStr("unSendMail", "CANNOT_DP_CONNECT") + " _unSendMail_Message_CallBack","");
					}
				else
					{
					dynAppend(g_unSendMail_ConnectList,"_unSendMail_CallBack");
					}
				}
			break;
		
		case REPORT:
			// connect to the callback function if not already done
			iRes=dynContains(g_unSendMail_ConnectList,"_unSendMail_Report_CallBack");
			if(iRes <= 0)
				{
				iRes = dpConnect("_unSendMail_Report_CallBack", false, dsCallBackParam[1]);
						
				if(iRes < 0)
					{
					fwException_raise(exceptionInfo, "ERROR", "_unSendMail_set_checking(): "+getCatStr("unSendMail", "CANNOT_DP_CONNECT") + " _unSendMail_Report_CallBack","");
					}
				else
					{
					dynAppend(g_unSendMail_ConnectList, "_unSendMail_Report_CallBack");
					}
				}
			break;
		}
	}
else
	fwException_raise(exceptionInfo, "ERROR", "_unSendMail_set_checking(): "+getCatStr("unSendMail", "PARAMETERS_MISSING") + " dsCallBackParam","");
}

// _unSendMail_Message_CallBack
/**
Purpose:
Callback function to send Mail

	@param sDataPoint_1: string, input, data point name
	@param sValue_1: string, input, Information

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
	. distributed system: no / must work in local
*/
_unSendMail_Message_CallBack(string sDataPoint_1, string sValue_1)
{
  string sFunction, sMessage, sDpe;
  dyn_string exceptionInfo;
  dyn_string dsCategory;
  dyn_string dsTempSplit;
  
  unProcess_getReportCategoryFunction("", UN_SEND_MAIL_KEY_GET_CATEGORY, sFunction, exceptionInfo);
  if(sFunction == "")
    _unSendMail_Mail(sDataPoint_1, sValue_1);
  else
  {
    if(isFunctionDefined(sFunction))
    {
      evalScript(dsCategory,"dyn_string main(string sValue) "+
                               "{" + 
                                "return " + sFunction + "(sValue); "+
                               "}", makeDynString(), sValue_1);
      _unSendMail_MailByCategory(sDataPoint_1, sValue_1, dsCategory);
    }
    else
    {
    		dsTempSplit=strsplit(sValue_1, SEPARATOR);
      if (dynlen(dsTempSplit)==4)
        sDpe=substr(dsTempSplit[DPE],0,strpos(dsTempSplit[DPE],":_alert_hdl"));
      else
        sDpe = sValue_1;
      sMessage="_unSendMail_Message_CallBack(), user function not defined: " + sFunction +", "+sDpe;
      fwException_raise(exceptionInfo, "ERROR", sMessage,"");
    }
  }
  if (dynlen(exceptionInfo)>0)
  {
    if(isFunctionDefined("unMessageText_sendException"))
      unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
  }			
}

//------------------------------------------------------------------------------------------------------------------------
// _unSendMail_Mail
/** send a Mail/SMS
  
@par Constraints
  None

@par Usage
  Internal

@par PVSS managers
  Ui, CTRL

@param sDataPoint_1  input, the DPE
@param sValue_1  input, the value
*/
_unSendMail_Mail(string sDataPoint_1, string sValue_1)
{
dyn_string dsReceiver, exceptionInfo, dsTempSplit, dsDpe, dsDp_toCheck, dsText, exceptionInfoTemp;
int iRes, iIndex, i, j, k, l, len, len_check, len_dpe, len_receiver, iProcess, iMax, iThread, iDay;
string sSender, sDomain, sSmtp, sMessage, sTime, sAlert_text, sDpe, sSystem, sDescription, sValue, sReceivers, sTitle, sMain, sText,sDesc, sLink;
string sHost, sIPAddress, sBody, sReceiverSMS, sReceiverMail;
  string sFunction;
  dyn_dyn_string dsRetFunction;

	sSystem=getSystemName();
	unGenericDpFunctions_getHostName(sSystem, sHost, sIPAddress);
	sSystem=substr(sSystem, 0, strpos(sSystem,":"));

	if (sValue_1!="")
		{		
		//Data
		dsTempSplit=strsplit(sValue_1, SEPARATOR);
		if (dynlen(dsTempSplit)==4)
			{	
			sDpe=substr(dsTempSplit[DPE],0,strpos(dsTempSplit[DPE],":_alert_hdl"));
			sTime=dsTempSplit[TIME];
			sAlert_text=dsTempSplit[ALERT_TEXT];
			sValue=dsTempSplit[VALUE];      
      sText=_unSendMail_convertValue2Text(sDpe, sValue);                        			
                                                
			//Description or Alias?
			iProcess=strpos(sDpe,"ProcessInput.");
			if (iProcess>=0)
				{
				sDescription=dpGetAlias(substr(sDpe,0,iProcess));
				if (sDescription=="")
					sDescription=sDpe;
				}
			else
				sDescription=unGenericDpFunctions_getDescription(sDpe);	
			
			//Parameters
			len=dynlen(g_dsType);
			for (i=1;i<=len;i++)						         //for each Category
				{
        iDay=day(getCurrentTime());                          
				if(g_diToday[strtolower(g_dsType[i])] != iDay)	   //new day => reset the counter
					{
					g_diToday[strtolower(g_dsType[i])] = iDay;
					g_diDayCounter[strtolower(g_dsType[i])] = 0;
					}	
				else
					_unSendMail_checkMapping(g_dsType[i]);	//check/init the mapping definition				

                                                                
        sscanf(g_dsMax[i],"%d",iMax);
				if(g_diDayCounter[strtolower(g_dsType[i])]<=iMax)	  	//to avoid processing if limit already reached
					{
					dsDpe=strsplit(g_dsDpe[i],SEPARATOR);
					len_dpe=dynlen(dsDpe);

					if (dynlen(g_dbDisable)>=i && dynlen(g_dsSender)>=i && dynlen(g_dsReceiver)>=i && dynlen(g_dsSender)>=i && dynlen(g_dsDomain)>=i) 	
						{
						if (!g_dbDisable[i])
							{
							sSender=g_dsSender[i];
							sDomain=g_dsDomain[i];
							sSmtp=g_dsSmtp[i];
							sLink =g_dsLink[i];
							
							
							if(sLink==c_LemonLink) // create lemon Link dynamically
								sLink = sLink + strtoupper(sHost);
								
							dsReceiver=strsplit(g_dsReceiver[i],DELEMITER);	
							len_receiver=dynlen(dsReceiver);	

							for (j=1;j<=len_dpe;j++)	//for each settings in the Category
								{
								dsDp_toCheck=dpNames(dsDpe[j]); 
								len_check=dynlen(dsDp_toCheck);	
								for (k=1;k<=len_check;k++)		//for each DP found in the Categorie
									{
									if (dsDp_toCheck[k]==sDpe)		//OK -> we send the message
										{																										
										sReceiverSMS="";
										sReceiverMail="";
										for (l=1;l<=len_receiver;l++)	//Send for each receiver
											{										
											if(!patternMatch(SMS_PATTERN, dsReceiver[l]))
												sReceiverMail=sReceiverMail+dsReceiver[l]+";";
											else
												sReceiverSMS=sReceiverSMS+dsReceiver[l]+";";
											}
                    
                    iThread=-2;										
										if(g_diDayCounter[strtolower(g_dsType[i])]==iMax)     //max mail reached
											{																		
											sMessage="_unSendMail_Mail(): " + getCatStr("unSendMail", "TOO_MUCH_MAIL") + " (" + iMax + ") - Category: " + g_dsType[i];
											fwException_raise(exceptionInfo, "ERROR", sMessage,"");
											if(sReceiverMail!="")
												{					
												dynClear(dsText);
												dynAppend(dsText, "Please check the application.\n");
												dynAppend(dsText, "The Max number of Emails (" + iMax + ") has been reached for the day. This category is disabled until midnight.\n");												
												iRes=_unSendMail_getText(sTime, sSystem, "WARNING", g_dsType[i], g_dsType[i], sHost, sIPAddress, sLink, dsText, sTitle, sBody);
                        iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);                                                                                                												
                        }
											if(sReceiverSMS!="")
												{
												iRes=_unSendMail_getTitle(sTime, sSystem, "WARNING", "Too much mail for this day", sTitle);
												sBody="";
                        iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);                                                                                                
												}                      
											}
										else if (g_diDayCounter[strtolower(g_dsType[i])]<iMax)	//max mail not reached
										{
                dynClear(dsRetFunction);
                sFunction = "";
                dynClear(exceptionInfoTemp);
                unProcess_getReportCategoryFunction("", g_dsType[i]+UN_SEND_MAIL_KEY_CATEGORY_MAIL_EXTENSION, sFunction, exceptionInfoTemp);
                dynAppend(exceptionInfo, exceptionInfoTemp);
                if(sFunction != "")
                {
                  if(isFunctionDefined(sFunction))
                  {
                    evalScript(dsRetFunction,"dyn_dyn_string main(string sCat, string sDpe, string sValue) "+
                                             "{" + 
                                              "return " + sFunction + "(sCat, sDpe, sValue); "+
                                             "}", makeDynString(), g_dsType[i], sDpe, sValue);
      
                    while(dynlen(dsRetFunction) <= UN_SEND_MAIL_BODY)
                      dynAppend(dsRetFunction, makeDynString("", ""));
                  }
                }
											if(sReceiverMail!="")
											{					
                  if(sFunction == "")
                  {
												//Format message
												  dynClear(dsText);
												  dynAppend(dsText, " " + sAlert_text + ":   " + sDescription + "\n");
												  dynAppend(dsText, "        Value = " + sText + "\n");
												  iRes=_unSendMail_getText(sTime, sSystem, sAlert_text, sDescription, g_dsType[i], sHost, sIPAddress, sLink, dsText, sTitle, sBody);
												  iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);
                  }
                  else
                  {
                    if(isFunctionDefined(sFunction))
                    {
                      sTitle = dsRetFunction[UN_SEND_MAIL_TITLE][MAIL_TITLE];
                      sBody = _unSendMail_convertBody(dsRetFunction[UN_SEND_MAIL_BODY]);
                          
                      iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);
                    }
                    else
                    {
                      sMessage="_unSendMail_Mail(): user function not defined: " + sFunction;
                      fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
                    }
                  }
											}
											
											if(sReceiverSMS!="")
											{
                  if(sFunction == "")
                  {
												  dynClear(dsText);
												  sDesc =unGenericDpFunctions_getDescription(sDpe);
												  dsText = strsplit(sDesc,SEPARATOR);	
												
												  if (dynlen(dsText)>=DESC)
													  sDesc = dsText[DESC];
												
												  iRes=_unSendMail_getTitle(sTime, sSystem, sAlert_text, sDescription, sTitle);
												  sBody = "";
												  iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);
                  }
                  else
                  {
                    if(isFunctionDefined(sFunction))
                    {
                      sTitle = dsRetFunction[UN_SEND_MAIL_TITLE][SMS_TITLE];
                      sBody = "";
                      iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);
                    }
                    else
                    {
                      sMessage="_unSendMail_Mail(): user function not defined: " + sFunction;
                      fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
                    }
                  }
											}													
										}										

                    if(iThread>=0)  g_diDayCounter[strtolower(g_dsType[i])]++;
										
										}			//if (dsDp_toCheck[k]==sDpe)
									}				//for (k=1;k<=len_check;k++)				
								}					//for (j=1;j<=len_dpe;j++)
							}						//if (g_dbDisable[i])
						}							//dynlen(g_dbDisable)>=i && dynlen(g_dsSender)>=i && dynlen(g_dsReceiver)>=i
					else							
						{
						sMessage="_unSendMail_Mail(): " + getCatStr("unSendMail", "PARAMETERS_MISSING") + dsDpe + " - " + i + " - " + dynlen(g_dbDisable) + " - " + dynlen(g_dsSender) + " - " + dynlen(g_dsReceiver) + " - " + dynlen(g_dsSender) + " - " + dynlen(g_dsDomain);
						fwException_raise(exceptionInfo, "ERROR", sMessage,"");	
						}							
					}					//!g_dbMax[i]			
				}						//for (i=1;i<=len;i++)								
			}							//for each Category
		else							//if (dynlen(dsTempSplit)==4)
			{
			sMessage="_unSendMail_Mail(): " + getCatStr("unSendMail", "CANNOT_GET_DATA");
			fwException_raise(exceptionInfo, "ERROR", sMessage,"");
			}
		}			
	else									//sValue_1!=""
		{
		sMessage="_unSendMail_Mail(): " + getCatStr("unSendMail", "CANNOT_GET_SETTINGS");
		fwException_raise(exceptionInfo, "ERROR", sMessage,"");
		}
			
	if (dynlen(exceptionInfo)>0)
		{
		if(isFunctionDefined("unMessageText_sendException"))
			unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
		}
}

//------------------------------------------------------------------------------------------------------------------------
// _unSendMail_MailByCategory
/** send a Mail/SMS 
  
@par Constraints
  None

@par Usage
  Internal

@par PVSS managers
  Ui, CTRL

@param sDataPoint_1  input, the DPE
@param sValue_1  input, the value
@param dsCategoryToSend  input, the list of category
*/
_unSendMail_MailByCategory(string sDataPoint_1, string sValue_1, dyn_string dsCategoryToSend)
{
  dyn_string dsReceiver, exceptionInfo, dsTempSplit, dsDp_toCheck, dsText, exceptionInfoTemp;
  int iRes, i, l, len, len_receiver, iMax, iThread, iDay;
  string sSender, sDomain, sSmtp, sMessage, sTime, sSystem, sReceivers, sTitle, sMain, sText,sDesc, sLink;
  string sHost, sIPAddress, sBody, sReceiverSMS, sReceiverMail;
  string sFunction;
  dyn_dyn_string dsRetFunction;
  dyn_string dsCategory=dsCategoryToSend;
  int iCatPos;
  
  sSystem=getSystemName();
  unGenericDpFunctions_getHostName(sSystem, sHost, sIPAddress);
  sSystem=substr(sSystem, 0, strpos(sSystem,":"));

  if (sValue_1!="")
  {    
    sTime=getCurrentTime();
    len=dynlen(g_dsType);
    for (i=1;i<=len;i++)                     //for each Category
    {
      iCatPos = dynContains(dsCategory, g_dsType[i]);
      if(iCatPos >= 1)
      {
        dynRemove(dsCategory, iCatPos);
        iDay=day(getCurrentTime());                          
        if(g_diToday[strtolower(g_dsType[i])] != iDay)     //new day => reset the counter
        {
          g_diToday[strtolower(g_dsType[i])] = iDay;
          g_diDayCounter[strtolower(g_dsType[i])] = 0;
        }  
        else
          _unSendMail_checkMapping(g_dsType[i]);  //check/init the mapping definition        
                                                                
        sscanf(g_dsMax[i],"%d",iMax);
        if(g_diDayCounter[strtolower(g_dsType[i])]<=iMax)      //to avoid processing if limit already reached
        {
          if (dynlen(g_dbDisable)>=i && dynlen(g_dsSender)>=i && dynlen(g_dsReceiver)>=i && dynlen(g_dsSender)>=i && dynlen(g_dsDomain)>=i)   
          {
            if (!g_dbDisable[i])
            {
              sSender=g_dsSender[i];
              sDomain=g_dsDomain[i];
              sSmtp=g_dsSmtp[i];
              sLink =g_dsLink[i];
              
              if(sLink==c_LemonLink) // create lemon Link dynamically
                sLink = sLink + strtoupper(sHost);
                
              dsReceiver=strsplit(g_dsReceiver[i],DELEMITER);  
              len_receiver=dynlen(dsReceiver);  

              sReceiverSMS="";
              sReceiverMail="";
              for (l=1;l<=len_receiver;l++)  //Send for each receiver
              {                    
                if(!patternMatch(SMS_PATTERN, dsReceiver[l]))
                  sReceiverMail=sReceiverMail+dsReceiver[l]+";";
                else
                  sReceiverSMS=sReceiverSMS+dsReceiver[l]+";";
              }
                    
              iThread=-2;                    
              if(g_diDayCounter[strtolower(g_dsType[i])]==iMax)     //max mail reached
              {                                    
                sMessage="_unSendMail_MailByCategory(): " + getCatStr("unSendMail", "TOO_MUCH_MAIL") + " (" + iMax + ") - Category: " + g_dsType[i];
                fwException_raise(exceptionInfo, "ERROR", sMessage,"");
                if(sReceiverMail!="")
                {          
                  dynClear(dsText);
                  dynAppend(dsText, "Please check the application.\n");
                  dynAppend(dsText, "The Max number of Emails (" + iMax + ") has been reached for the day. This category is disabled until midnight.\n");                        
                  iRes=_unSendMail_getText(sTime, sSystem, "WARNING", g_dsType[i], g_dsType[i], sHost, sIPAddress, sLink, dsText, sTitle, sBody);
                  iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);                                                                                                                        
                }
                if(sReceiverSMS!="")
                {
                  iRes=_unSendMail_getTitle(sTime, sSystem, "WARNING", "Too much mail for this day", sTitle);
                  sBody="";
                  iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);                                                                                                
                }                      
              }
              else if (g_diDayCounter[strtolower(g_dsType[i])]<iMax)  //max mail not reached
              {
                dynClear(dsRetFunction);
                sFunction = "";
                dynClear(exceptionInfoTemp);
                unProcess_getReportCategoryFunction("", g_dsType[i]+UN_SEND_MAIL_KEY_CATEGORY_MAIL_EXTENSION, sFunction, exceptionInfoTemp);
                dynAppend(exceptionInfo, exceptionInfoTemp);
                if(sFunction != "")
                {
                  if(isFunctionDefined(sFunction))
                  {
                    evalScript(dsRetFunction,"dyn_dyn_string main(string sCat, string sDpe, string sValue) "+
                                             "{" + 
                                              "return " + sFunction + "(sCat, sDpe, sValue); "+
                                             "}", makeDynString(), g_dsType[i], "", sValue_1);
      
                    while(dynlen(dsRetFunction) <= UN_SEND_MAIL_BODY)
                      dynAppend(dsRetFunction, makeDynString("", ""));
                  }
                }
                if(sReceiverMail!="")
                {          
                  if(sFunction == "")
                  {
                      sMessage="_unSendMail_MailByCategory(): user function empty ("+g_dsType[i]+")";
                      fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
                  }
                  else
                  {
                    if(isFunctionDefined(sFunction))
                    {
                      sTitle = dsRetFunction[UN_SEND_MAIL_TITLE][MAIL_TITLE];
                      sBody = _unSendMail_convertBody(dsRetFunction[UN_SEND_MAIL_BODY]);
                          
                      iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);
                    }
                    else
                    {
                      sMessage="_unSendMail_MailByCategory(): user function not defined: " + sFunction +" ("+g_dsType[i]+")";
                      fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
                    }
                  }
                }
                      
                if(sReceiverSMS!="")
                {
                  if(sFunction == "")
                  {
                      sMessage="_unSendMail_MailByCategory(): user function empty ("+g_dsType[i]+")";
                      fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
                  }
                  else
                  {
                    if(isFunctionDefined(sFunction))
                    {
                      sTitle = dsRetFunction[UN_SEND_MAIL_TITLE][SMS_TITLE];
                      sBody = "";
                      iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, g_dsType[i]);
                    }
                    else
                    {
                      sMessage="_unSendMail_MailByCategory(): user function not defined: " + sFunction +" ("+g_dsType[i]+")";
                      fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
                    }
                  }
                }                          
              }                    

              if(iThread>=0)  
                g_diDayCounter[strtolower(g_dsType[i])]++;
                    
            } //if (g_dbDisable[i])
          } //dynlen(g_dbDisable)>=i && dynlen(g_dsSender)>=i && dynlen(g_dsReceiver)>=i
          else              
          {
            sMessage="_unSendMail_MailByCategory(): " + getCatStr("unSendMail", "PARAMETERS_MISSING") + " - " + i + " - " + dynlen(g_dbDisable) + " - " + dynlen(g_dsSender) + " - " + dynlen(g_dsReceiver) + " - " + dynlen(g_dsSender) + " - " + dynlen(g_dsDomain);
            fwException_raise(exceptionInfo, "ERROR", sMessage,"");  
          }              
        } //!g_dbMax[i] 
      } // category in list
    } //for (i=1;i<=len;i++)  //for each Category   
    if(dynlen(dsCategory) > 0)
    {
      sMessage="_unSendMail_MailByCategory(): unknown category or max mail/per day reached " + dsCategory;
      fwException_raise(exceptionInfo, "ERROR", sMessage,"");
    }      
  }      
  else                  //sValue_1!=""
  {
    sMessage="_unSendMail_MailByCategory(): empty value";
    fwException_raise(exceptionInfo, "ERROR", sMessage,"");
  }
      
  if (dynlen(exceptionInfo)>0)
  {
    if(isFunctionDefined("unMessageText_sendException"))
      unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
  }
}

//------------------------------------------------------------------------------------------------------------------------

// _unSendMail_Settings_CallBack
/**
Purpose:
Callback function to save settings

	@param sDataPoint_1: string, input, data point name
	@param dsSettings: dyn_string, input, Settings: Type / From / To 
	@param sDataPoint_2: string, input, data point name
	@param dbDisable: dyn_string, input, Disable Sending?

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

_unSendMail_Settings_CallBack(string sDataPoint_1, dyn_string dsSettings, string sDataPoint_2, dyn_string dbDisable, string sDataPoint_3, dyn_string dsReport)
{
int i, iMax, len=dynlen(dsSettings);
dyn_string dsField;

  synchronized (g_dsType)
  {
    dynClear(g_dsType);
    dynClear(g_dsDomain);
    dynClear(g_dsSmtp);
    dynClear(g_dsSender);
    dynClear(g_dsReceiver);
    dynClear(g_dsLink);
    dynClear(g_dsMax);
    dynClear(g_dbDisable);
    dynClear(g_dsDpe);
    for (i=1;i<=len;i++)				//for each Type of Category
  	{
  	dsField=strsplit(dsSettings[i],SEPARATOR);
                        
  	if (dynlen(dsField)>=5)
  		{
  		g_dsType[i]=dsField[TYPE];
  		g_diToday[strtolower(g_dsType[i])]=0;                
  		g_dsDomain[i]=dsField[DOMAIN];
  		g_dsSmtp[i]=dsField[SMTP];
  		g_dsSender[i]=dsField[SENDER];
  		g_dsReceiver[i]=strtolower(dsField[RECEIVER]);

  		if(dynlen(dsField)>5)
  			{
  			g_dsLink[i]=dsField[LINK];
  			if(dynlen(dsField)>6)
  				g_dsMax[i]=dsField[MAX];
  			else
  				g_dsMax[i]=c_iMaxMailPerDay;			
  			}
  		else
  		 	{
  			g_dsMax[i]=c_iMaxMailPerDay;
  		 	g_dsLink[i]="";
  		 	}
  		}	
  	else
  		{
  		g_dsType[i]="";
  		g_dsDomain[i]="";
  		g_dsSmtp[i]="";
  		g_dsSender[i]="";
  		g_dsReceiver[i]="";
  		g_dsLink[i]="";
  		g_dsMax[i]="";
  		}
  	}

    g_dbDisable=dbDisable;
    g_dsDpe=dsReport;
  }
}

// _unSendMail_Report_CallBack
/**
Purpose:
Callback function to send a report

	@param sDataPoint_1: string, input, data point name
	@param sType: string, input, scheduler Type

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
	. distributed system: no / must work in local
*/

_unSendMail_Report_CallBack(string sDataPoint_1, string sType)
{
  string sFunction;
  dyn_string exceptionInfo;
  
  unProcess_getReportCategoryFunction("", sType+UN_SEND_MAIL_KEY_CATEGORY_REPORT_EXTENSION, sFunction, exceptionInfo);
  if(sFunction == "")
    _unSendMail_Report(sDataPoint_1, sType);
  else
    _unSendMail_ReportUserFunction(sDataPoint_1, sType, sFunction);
}

//------------------------------------------------------------------------------------------------------------------------
// _unSendMail_Report
/** send a report
  
@par Constraints
  None

@par Usage
  Internal

@par PVSS managers
  Ui, CTRL

@param sDataPoint_1  input, system name
@param sType  input, the mail/SMS category
*/
_unSendMail_Report(string sDataPoint_1, string sType)
{
dyn_string dsDpe, dsDp_toCheck, dsReceiver, exceptionInfo, dsText;
string sText, sTitle, sMessage, sDp, sSystem, sDpe, sTime, sAlarm, sInformation, sValue, sBlank_1, sAck, s1, s2, sSender, sDomain, sSmtp, sLink;
string sHost, sIPAddress, sBad, sBackup, sBody, sReceiverSMS, sReceiverMail;
time tTime;
int iIndex, iThread, iRes, len_check, len, i, j, len1, len10, len20, iProcess, iBad = 0;

	sSystem=getSystemName();
	sSystem=substr(sSystem, 0, strpos(sSystem,":"));
	sHost=getHostname();
	sIPAddress=unConfigGenericFunctions_getMyIP();
	
	tTime=getCurrentTime();
	sTime=formatTime("%m/%d/%Y  %H:%M:%S", tTime);	
	
	sBlank_1="                                             ";   //use to format text message (len=13)
	len1=strlen(sBlank_1);
			
	iIndex=dynContains(g_dsType, sType);
	if (iIndex>0)
		{
		if (dynlen(g_dsLink)>=iIndex)
			{
				sLink = g_dsLink[iIndex];
			}
		else sLink="";
		
		if(sLink==c_LemonLink) // create lemon Link dynamically
			sLink = sLink + strtoupper(sHost);
		
		// check if backup is ok
		if(dpExists(c_DPE_Backup))
			{
			string sLastBackup, sTimeLastBackup;
			time tTimeLastBackup;
			
			dpGet(c_DPE_Backup, sLastBackup);
			dpGet(c_DPE_Backup+":_online.._stime", tTimeLastBackup);
			sTimeLastBackup = tTimeLastBackup;
			
			if((getCurrentTime()-tTimeLastBackup)>= 86400)
				{
				len10=strlen("Bad");
				len20=strlen("Not executed");
				s2=substr(sBlank_1, 0, len1 - len20);				
				sBackup= "         - " + " Bad\t   " + "Not executed" + s2 + "Online Backup";
				}
			else
				{
				if (sLastBackup!="")
					{
					len10=strlen(sLastBackup);
					len20=strlen(sTimeLastBackup);
					s2=substr(sBlank_1, 0, len1 - len20);				
					sBackup= "         - " + " " + sLastBackup + "\t   " + sTimeLastBackup + s2 + "Online Backup";				
					}
				}	
			}

		dynAppend(dsText, "   \t\tAlert\t   Value\t\t\t\t\t\t\tName\n\n");
		dynAppend(dsText, sBackup + "\n");

		if (dynlen(g_dbDisable)>=iIndex && dynlen(g_dsSender)>=iIndex && dynlen(g_dsReceiver)>=iIndex && dynlen(g_dsSender)>=iIndex && dynlen(g_dsDomain)>=iIndex) 	
			{
			if (!g_dbDisable[iIndex]) 
				{		
				dsDpe=strsplit(g_dsDpe[iIndex],"~");
				len=dynlen(dsDpe);
				
				for (i=1;i<=len;i++)					//for each dpe pattern
					{
					dsDp_toCheck=dpNames(dsDpe[i]); 
					len_check=dynlen(dsDp_toCheck);
						
					for (j=1;j<=len_check;j++)	//for each dpe
						{
						sValue="";
						sAlarm="";
						sInformation="";
						
						//Get Value and Alert Text
						_unSendMail_Status_Value(dsDp_toCheck[j], sValue, sAlarm, sInformation);
            sText=_unSendMail_convertValue2Text(dsDp_toCheck[j], sValue);
            
						//Description or Alias?
						iProcess=strpos(dsDp_toCheck[j],"ProcessInput.");
						if (iProcess>=0)
							{
							sDpe=dpGetAlias(substr(dsDp_toCheck[j],0,iProcess));
							if (sDpe=="")
								sDpe=dsDp_toCheck[j];
							}
						else
							sDpe=unGenericDpFunctions_getDescription(dsDp_toCheck[j]);				
				
						len10=strlen(sAlarm);
						len20=strlen(sText);
						s1=substr(sBlank_1, 0, len1 - len10);
						s2=substr(sBlank_1, 0, len1 - len20);

						dynAppend(dsText, sInformation + " " + sAlarm + "\t   " + sText + s2 + sDpe + "\n");
						
						if ((sInformation != "Disable  - ") && (sAlarm != "Ok")) 
							{
								iBad++;
								if (iBad ==1)
									sBad = "Bad "+sDpe;
								else
									sBad = "Bad >1";
							}				
						}
					}
								
				
				if (dynlen(g_dsSender)>=iIndex)
					{
					sSender=g_dsSender[iIndex];
					sDomain=g_dsDomain[iIndex];
					sSmtp=g_dsSmtp[iIndex];
					dsReceiver=strsplit(g_dsReceiver[iIndex],DELEMITER);	
					}
				else
					sSender="";

				sReceiverSMS="";
				sReceiverMail="";					
				len=dynlen(dsReceiver);	
				if (len>0 && sSender!="") 
					{
					for (i=1;i<=len;i++)
						{
						if(!patternMatch(SMS_PATTERN, dsReceiver[i]))
							sReceiverMail=sReceiverMail+dsReceiver[i]+";";
						else
							sReceiverSMS=sReceiverSMS+dsReceiver[i]+";";
						}	
						
					if(sReceiverSMS!="")
						{
						//Format ONLY the title
						sBody="";
						if(iBad >0)
							iRes=_unSendMail_getTitle(sTime, sSystem, "Report", sBad, sTitle);
						else
							iRes=_unSendMail_getTitle(sTime, sSystem, "Report", "Ok", sTitle);
						iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, sType);
						}
					
					if(sReceiverMail!="")
						{
						//Format message
						iRes=_unSendMail_getText(sTime, sSystem, "Report", sType, sType, sHost, sIPAddress, sLink, dsText, sTitle, sBody);
						iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, sType);
						}					
					}
				else
					{
					sMessage="_unSendMail_Report(): " + getCatStr("unSendMail", "WRONGSENDER");
					fwException_raise(exceptionInfo, "ERROR", sMessage,"");	
					}
				}
			}
		else
			{
			sMessage="_unSendMail_Report(): " + getCatStr("unSendMail", "PARAMETERS_MISSING");
			fwException_raise(exceptionInfo, "ERROR", sMessage,"");
			}
		}
	else
		{
		sMessage="_unSendMail_Report(): " + getCatStr("unSendMail", "UNKNOWNCATEGORIE") + sType;
		fwException_raise(exceptionInfo, "ERROR", sMessage,"");	
		}
		
			
if (dynlen(exceptionInfo)>0)
	{
	if(isFunctionDefined("unMessageText_sendException"))
		unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
	}			
}

//------------------------------------------------------------------------------------------------------------------------
// _unSendMail_ReportUserFunction
/** send a report with a user defined function
  
@par Constraints
  None

@par Usage
  Internal

@par PVSS managers
  Ui, CTRL

@param sDataPoint_1  input, system name
@param sType  input, the mail/SMS category
@param sFunction  input, the user function
*/
_unSendMail_ReportUserFunction(string sDataPoint_1, string sType, string sFunction)
{
  dyn_string dsDpe, dsDp_toCheck, dsReceiver, exceptionInfo, dsText;
  string sText, sTitle, sMessage, sDp, sSystem, sDpe, sTime, sAlarm, sInformation, sValue, sBlank_1, sAck, s1, s2, sSender, sDomain, sSmtp, sLink;
  string sHost, sIPAddress, sBad, sBackup, sBody, sReceiverSMS, sReceiverMail;
  time tTime;
  int iIndex, iThread, iRes, len_check, len, i, j, len1, len10, len20, iProcess, iBad = 0;
  dyn_dyn_string dsRetFunction;

  sSystem=getSystemName();
  sSystem=substr(sSystem, 0, strpos(sSystem,":"));
  sHost=getHostname();
  sIPAddress=unConfigGenericFunctions_getMyIP();
  
  tTime=getCurrentTime();
  sTime=formatTime("%m/%d/%Y  %H:%M:%S", tTime);	
  
  sBlank_1="                                             ";   //use to format text message (len=13)
  len1=strlen(sBlank_1);
  
  iIndex=dynContains(g_dsType, sType);
  if(iIndex>0)
  {
    if (dynlen(g_dbDisable)>=iIndex && dynlen(g_dsSender)>=iIndex && dynlen(g_dsReceiver)>=iIndex && dynlen(g_dsSender)>=iIndex && dynlen(g_dsDomain)>=iIndex) 	
    {
      if(!g_dbDisable[iIndex]) 
				{		
				  dsDpe=strsplit(g_dsDpe[iIndex],"~");
        if(isFunctionDefined(sFunction))
        {
          evalScript(dsRetFunction,"dyn_dyn_string main(string sCat, dyn_string dsDpe) "+
                                   "{" + 
                                    "return " + sFunction + "(sCat, dsDpe); "+
                                   "}", makeDynString(), sType, dsDpe);
      
          while(dynlen(dsRetFunction) <= UN_SEND_MAIL_BODY)
            dynAppend(dsRetFunction, makeDynString("", ""));
          if (dynlen(g_dsSender)>=iIndex)
          {
            sSender=g_dsSender[iIndex];
            sDomain=g_dsDomain[iIndex];
            sSmtp=g_dsSmtp[iIndex];
            dsReceiver=strsplit(g_dsReceiver[iIndex],DELEMITER);	
          }
          else
            sSender="";

          sReceiverSMS="";
          sReceiverMail="";					
          len=dynlen(dsReceiver);	
          if (len>0 && sSender!="") 
          {
            for (i=1;i<=len;i++)
            {
              if(!patternMatch(SMS_PATTERN, dsReceiver[i]))
                sReceiverMail=sReceiverMail+dsReceiver[i]+";";
              else
                sReceiverSMS=sReceiverSMS+dsReceiver[i]+";";
            }	

            if(sReceiverSMS!="")
            {
              //Format ONLY the title
              sTitle = dsRetFunction[UN_SEND_MAIL_TITLE][SMS_TITLE];
              iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, "", sType);
            }
            if(sReceiverMail!="")
            {
              //Format message
              sTitle = dsRetFunction[UN_SEND_MAIL_TITLE][MAIL_TITLE];
              sBody = _unSendMail_convertBody(dsRetFunction[UN_SEND_MAIL_BODY]);
              iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, sType);
            }					
          }
          else
          {
            sMessage="_unSendMail_Report(): " + getCatStr("unSendMail", "WRONGSENDER");
            fwException_raise(exceptionInfo, "ERROR", sMessage,"");	
          }
        }
        else
        {
          sMessage="_unSendMail_ReportUserFunction(), user function not defined: " + sFunction;
          fwException_raise(exceptionInfo, "ERROR", sMessage,"");
        }
      }
    }
    else
    {
      sMessage="_unSendMail_ReportUserFunction(): " + getCatStr("unSendMail", "PARAMETERS_MISSING");
      fwException_raise(exceptionInfo, "ERROR", sMessage,"");
    }
  }
  else
  {
    sMessage="_unSendMail_ReportUserFunction(): " + getCatStr("unSendMail", "UNKNOWNCATEGORIE") + sType;
    fwException_raise(exceptionInfo, "ERROR", sMessage,"");	
  }

  if (dynlen(exceptionInfo)>0)
  {
    if(isFunctionDefined("unMessageText_sendException"))
      unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
  }			
}

//------------------------------------------------------------------------------------------------------------------------
// _unSendMail_convertBody
/** Convert the body to send by email
  
@par Constraints
  None

@par Usage
  Internal

@par PVSS managers
  Ui, CTRL

@param dsBody  input, the content of the email
@return the body of the email
*/
string _unSendMail_convertBody(dyn_string dsBody)
{
  int i, len=dynlen(dsBody);
  string sReturn;
  
  for(i=1;i<=len;i++)
    sReturn = sReturn+dsBody[i]+"\n";
  return sReturn;
}

// _unSendMail_Status_Value
/**
Purpose:
Callback function to save settings

	@param sDataPoint_1: string, input, data point name
	@param iVal: int, output, value
	@param sAl: string, output, Alert text
	@param sAck: string, output, Alert needs to be acknowledge or Disable

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
	. distributed system: no / must work in local
*/

_unSendMail_Status_Value(string sDpe, string &sVal, string &sAl, string &sInfo)
{
int iAlert_Type, iRes;
bool bNeedAck, bEnabled;

	sInfo="         - ";
	
	iRes=dpGet(sDpe + ":_alert_hdl.._type", iAlert_Type, sDpe + ":_alert_hdl.._active", bEnabled);
	iRes=iRes + dpGet(sDpe, sVal);
	
	if (iRes>=0)	
		{
		if(iAlert_Type!=DPCONFIG_NONE)
			{
			iRes=dpGet(sDpe + ":_alert_hdl.._act_text", sAl);
			iRes=dpGet(sDpe + ":_alert_hdl.._ack_possible", bNeedAck);

			if (bNeedAck && bEnabled)	//Alert needs to ba acknowledge
				sInfo="Need Ack - ";
			
			if (!bEnabled)
				sInfo="Disable  - ";
			}
		else
			sAl="NONE";
		}
	else
		{
		sVal="-1";
		sAl="?";
		}
}

// _unSendMail_Message
/**
Purpose:
Callback function to send a message

	@param sReceiver: string, input, Receiver address
	@param sSender: string, input, Sender address
	@param sSmtp: string, input, smtp server name
	@param sDomain: string, input, domain name
	@param sTitle: string, input, Mail title
	@param sMain: string, input, Mail text
	@param sType: string, input, Categorie

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

_unSendMail_Message(string sReceiver, string sSender, string sSmtp, string sDomain, string sTitle, string sMain, string sType)
{
dyn_string dsParam, exceptionInfo, dsResult;
string sMessage, sPath, sTime, sChar;
file fLog;
int iRes, iLen;
	if (sReceiver!="" && sSender!="" && sSmtp!="" && sDomain!="" && strpos(sReceiver,"@")>=0 && strpos(sSender,"@")>=0) 
		{
		dsParam[1]=sReceiver; 
		dsParam[2]=sSender; 
		dsParam[3]=sTitle; 
		dsParam[4]=sMain; 
				
		emSendMail(sSmtp, sDomain, dsParam, iRes);  
		if(iRes!=0)    //try to resend one time the message if an error occured
			{
			delay(DELAY_RESEND);
			emSendMail(sSmtp, sDomain, dsParam, iRes);
			}
	
		//save Result
		sTime=formatTime("%m/%d/%Y  %H:%M:%S", getCurrentTime());
		if (iRes==0)
			sMessage=sTitle + " successfully sent to " + dsParam[1] + " at " + sTime;
		else
			sMessage="Error during sending  " + sTitle + " to " + dsParam[1] + " at " + sTime;

		fwException_raise(exceptionInfo, "EXPERTINFO", sMessage,"");
		
		//Writ Log
    iLen=strlen(sReceiver);                
    sChar=substr(sReceiver,(iLen-1),1);
    if(sChar==";")         
      sReceiver=substr(sReceiver,0,(iLen-1));   
                                         
		sPath = getPath(LOG_REL_PATH) + sType + "_to_" + sReceiver + ".txt";
		fLog = fopen(sPath, "w");
		if (fLog != 0)
			{
			fputs(sMain, fLog);
			fclose(fLog);
			}		
		}
	else
		{
		sMessage="_unSendMail_Message(): " + getCatStr("unSendMail", "WRONGSENDER");
		fwException_raise(exceptionInfo, "ERROR", sMessage,"");	
		}
		
if (dynlen(exceptionInfo)>0)
	{
	if(isFunctionDefined("unMessageText_sendException"))
		unMessageText_sendException("*", "*", g_Mail_sSystemName+"SendMail", "user", "*", exceptionInfo);
	}	
}

// unSendMail_Init
/**
Purpose:
send a Email when system starts 

	@param dsSettings: dyn_string, input, Settings
	@param dbDisable: dyn_bool, input, Categorie Disable?

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
	. distributed system: no / must work in local
*/

unSendMail_Init()
{
int i, l, len, len_receiver, iRes, iThread;
time t;
string sTime, sType, sTitle, sMain, sLink; 
string sSender, sDomain, sSmtp, sBody;
string sHost, sIPAddress, sSystem, sReceiverMail, sReceiverSMS;
dyn_string dsReceivers,	dsText;
bool bStartup;
string sStartup;
dyn_string exceptionInfo;

	sSystem=getSystemName();
	sSystem=substr(sSystem,0,strpos(sSystem,":"));

	sHost=getHostname();
	sIPAddress=unConfigGenericFunctions_getMyIP();
	
	t=getCurrentTime();
	sTime=formatTime("%m/%d/%Y  %H:%M:%S", t," (milli: %03d)");  

	sType="Starting";
	
	len=dynlen(g_dsType);
	for (i=1;i<=len;i++)				//for each Category
		{
		g_diDayCounter[strtolower(g_dsType[i])]=0;
		g_diToday[strtolower(g_dsType[i])]=0;
                
		if (!g_dbDisable[i])
			{
      bStartup = false;
      dynClear(exceptionInfo);
      sStartup = "";
    unProcess_getReportCategoryFunction(getSystemName(), g_dsType[i]+UN_SEND_MAIL_KEY_CATEGORY_STARTUP, sStartup, exceptionInfo);
    if(dynlen(exceptionInfo) <=0)
      bStartup = sStartup;
//DebugN(g_dsType[i], exceptionInfo, sStartup, bStartup);
      if(bStartup)
      {
			sSender=g_dsSender[i];
			sDomain=g_dsDomain[i];
			sSmtp=g_dsSmtp[i];
			sLink =g_dsLink[i];
						
			if(sLink==c_LemonLink) // create lemon Link dynamically
				sLink = sLink + strtoupper(sHost);

			dynClear(dsText);
			iRes=_unSendMail_getText(sTime, sSystem, sType, "Information", g_dsType[i], sHost, sIPAddress, sLink, dsText, sTitle, sMain);

			dsReceivers=strsplit(g_dsReceiver[i],DELEMITER);	
			len_receiver=dynlen(dsReceivers);
                        			
			sReceiverSMS="";
			sReceiverMail="";
			for (l=1;l<=len_receiver;l++)	//Send for each receiver
				{
				if(!patternMatch(SMS_PATTERN, dsReceivers[l]))
					sReceiverMail=sReceiverMail+dsReceivers[l]+";";
				else
					sReceiverSMS=sReceiverSMS+dsReceivers[l]+";";
				}
				
			if(sReceiverSMS!="")
				{
				sBody="";
				iThread=startThread("_unSendMail_Message", sReceiverSMS, sSender, sSmtp, sDomain, sTitle, sBody, sType);				
				}
				
			if(sReceiverMail!="")
				{
				sBody=sMain;
				iThread=startThread("_unSendMail_Message", sReceiverMail, sSender, sSmtp, sDomain, sTitle, sBody, sType);
				}
			}
    }
		}	
}

// _unSendMail_getTitle
/**
Purpose:
get only Title text

	@param sTime: string, input, Message Time
	@param sSystemName: string, input, Local PVSS system name
	@param sMessageType: string, input, Message type
	@param sInfo: string, input, info
	@param sTitle: string, output, Title Text        

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

int _unSendMail_getTitle(	const string sTime,
													const string sSystemName,
													const string sMessageType,
													const string sInfo,
													string &sTitle)
{
	sTitle = sSystemName + " - " + sMessageType + " - " + sInfo + " - " + sTime; 
	return 0;
}

// _unSendMail_getText
/**
Purpose:
get Title and Main text

	@param sTime: string, input, Message Time
	@param sSystemName: string, input, Local PVSS system name
	@param sMessageType: string, input, Message type
	@param sInfo: string, input, info
	@param sCategory: string, input, Category name
	@param sHost: string, input, Local Hostname
	@param sIPAddress: string, input, Local IP Address                        
	@param sLink: string, input, HTML Link
	@param dsBody: dyn_string, input, Body Text
	@param sTitle: string, output, Title Text 
	@param sMain: string, output, Main Text 
        
Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

int _unSendMail_getText(	const string sTime,
													const string sSystemName,
													const string sMessageType,
													const string sInfo,
													const string sCategory,
													const string sHost,
													const string sIPAddress,
													const string sLink,
													const dyn_string dsBody,
													string &sTitle,
													string &sMain)
{
int iRes, iLen, i;
dyn_string dsMain;
	
	//init
	sTitle="";
	sMain="";
	dynClear(dsMain);
	
	//format the title
	iRes=_unSendMail_getTitle(sTime, sSystemName, sMessageType, sInfo, sTitle);
	
	//format the main text	
	dynAppend(dsMain, "UNICOS-PVSS v" + g_sVersion + ": " + sTime + "\n");
	dynAppend(dsMain, "Type: " + sMessageType + "\n");
	dynAppend(dsMain, "System Name: " +  sSystemName + "\n");
	dynAppend(dsMain, "Category: " + sCategory + "\n\n");
	dynAppend(dsMain, "DS Host Name: " +  sHost + "\n");
	dynAppend(dsMain, "DS IP Address: " + sIPAddress  + "\n\n");
	dynAppend(dsMain, sLink	+ "\n\t\t------------------------\n\n");
	dynAppend(dsMain, dsBody);
	dynAppend(dsMain, "\n");
	
	iLen=dynlen(dsMain);
	for (i=1; i<=iLen; i++)
		sMain=sMain+dsMain[i];
	
	return iRes;	
}

// _unSendMail_checkMapping
/**
Purpose:
check if the key is defined in the Globals mapping

	@param sCategory: string, input, Key name

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

void _unSendMail_checkMapping(const string sCategory)
{
string sKey=strtolower(sCategory);

	if (!mappingHasKey(g_diDayCounter, sKey))
		g_diDayCounter[sKey]=0;

	if (!mappingHasKey(g_diToday, sKey))
		g_diToday[sKey]=0;        
                		
}

// _unSendMail_convertValue2Text
/**
Purpose:
convert Value to Text description (LHCLogging/Laser/CMWServer)

	@param sDpe: string, input, Dpe name
	@param sValue: string, input, value        

Usage: Internal

PVSS manager usage: CTRL (PVSS00CTRL)

Constraints:
	. PVSS version: 3.1 
	. operating system: XP, SLC4
*/

string _unSendMail_convertValue2Text(const string sDpe, const string sValue)
{
string sText;
                              			
  if(sValue!="")
    {
    if (strpos(sDpe,"LHCLogging")>0)
      {                          
    	if(isFunctionDefined("unSystemIntegrity_LHCLogging_Initialize"))
        sText = getCatStr("unLHCLogging", sValue) + " (" + sValue + ")";
  		}
  
  	if (strpos(sDpe,"Laser")>0)
      {                          
    	if(isFunctionDefined("unSystemIntegrity_Laser_Initialize"))
        sText = getCatStr("unLaser", sValue) + " (" + sValue + ")";
  		}

    if (strpos(sDpe,"CMWServer")>0)
      {                          
    	if(isFunctionDefined("unSystemIntegrity_CMWServer_Initialize"))
        sText = getCatStr("unCMWServer", sValue) + " (" + sValue + ")";
  		}

    if(sText=="")
      sText=sValue; 
    }
  else
    sText="? - no value"; 
    
  return sText;  
}
//@}
