//////////////////////////////////////////////////////////////////////////////
// main calls the needed function
// fct = 1: upDpGetAddress
// fct = 2: upDpSetAddress
// fct = 3: upWritePanelAllAddressAttributes
// fct = 4: upReadPanelAllAddressAttributes
//////////////////////////////////////////////////////////////////////////////

anytype main(string dpe, int Id, anytype dpc, int fct)
{
  bool ok, all_right;
  
  switch (fct)
  {
    case 1: upDpGetAddress(dpe, Id, dpc);
      break;
    case 2: upDpSetAddress(dpe, Id, dpc, all_right); dpc[99]=all_right;
      break;
    case 3: upWritePanelAllAddressAttributes(dpe, Id, dpc);
      break;
    case 4: upReadPanelAllAddressAttributes(dpe, Id, dpc, all_right); dpc[99]=all_right;
      break;
  }
  return (dpc);
}

//////////////////////////////////////////////////////////////////////////////
// this function reads the datapoint values
//////////////////////////////////////////////////////////////////////////////
upDpGetAddress(string dpe, int Id, anytype &dpc)
{
  int         cmw_driver, cmw_mode, cmw_subindex, cmw_datatype, cmw_interval, cmw_dir;
  string      cmw_reference, cmw_drvident;
  string      cmw_config = paGetDpConfig(globalOpenConfig[Id]);
  bool cmw_active,cmw_lowlevel;
  
  switch (globalAddressOld[Id])  
  {  
    // CMWClient Driver
  case fwPeriphAddress_TYPE_CMW:
//      DebugN("get");
      dpGet(dpe+":"+cmw_config+".._reference", cmw_reference,
            dpe+":"+cmw_config+".._subindex",  cmw_subindex,
            dpe+":"+cmw_config+".._mode",      cmw_mode,
	           dpe+":"+cmw_config+".._lowlevel", cmw_lowlevel,
            dpe+":"+cmw_config+".._direction", cmw_dir,            
            dpe+":"+cmw_config+".._interval",  cmw_interval,
            dpe+":"+cmw_config+".._datatype",  cmw_datatype,
            dpe+":"+cmw_config+".._drv_ident", cmw_drvident,
            dpe+":_distrib.._driver",      cmw_driver,
            dpe + ":_address.._active", 	cmw_active);

        if (cmw_driver < 1) cmw_driver = 1;

        dpc[1] = cmw_reference;
        dpc[2] = cmw_subindex;
        dpc[3] = cmw_dir;
        dpc[4] = cmw_lowlevel;
        dpc[5] = cmw_interval;
        dpc[7] = cmw_datatype;
        dpc[8] = cmw_drvident;
        dpc[9] = cmw_driver;
			
        dpc[12]=cmw_active;  
			
      break;
      
  default: break;
  }
}

//////////////////////////////////////////////////////////////////////////////
upDpSetAddress(string dpe, int Id, dyn_anytype dpc, bool &all_right)  
{  
  string      cmw_config = paGetDpConfig(globalOpenConfig[Id]);
  int iMode,iDir,iTrans;
  bool bLowlevel;
  bool bActive;
  
  switch (globalAddressOld[Id])  
  {  
    // CMWClient Driver  
    case fwPeriphAddress_TYPE_CMW:

//    DebugN("setTransformation",dpc);
		bActive = activeCheckButton_CMW.state(0);
 		bLowlevel=lowlevel_CMW.state(0);
 		iMode = mode_CMW.number;
 		iDir = direction_CMW.number;
		iTrans = transformation_CMW.selectedPos;		 		
//		fwPeriphAddressCMW_setTransformation(dpc[3],iMode,dpc[7],bLowlevel,dpe);
		fwPeriphAddressCMW_setTransformation(iDir,iMode,iTrans,bLowlevel,dpe);
		dpc[3]=iDir;
		dpc[4]=bLowlevel;
		dpc[7]=iTrans;
		dpc[12] = bActive;
//		    DebugN("set",dpc);
		dpSetWait(dpe+":_address.._mode",iMode);


        paErrorHandlingDpSet(dpSetWait(dpe + ":_distrib.._driver", dpc[9]), all_right);
        paErrorHandlingDpSet(dpSetWait(dpe+":_address.._type", DPCONFIG_PERIPH_ADDR_MAIN,
                                       dpe+":"+cmw_config+".._reference",dpc[1],  
                                       dpe+":"+cmw_config+".._subindex",dpc[2],  
                                    //   dpe+":"+cmw_config+".._mode",dpc[3],  
                                       dpe+":"+cmw_config+".._direction",dpc[3],  
                                        dpe+":"+cmw_config+".._lowlevel",dpc[4], 
                                       dpe+":"+cmw_config+".._interval",dpc[5],  
                                       dpe+":"+cmw_config+".._datatype",dpc[7],  
                                       dpe+":"+cmw_config+".._drv_ident",dpc[8],
							dpe+":"+cmw_config+".._active", bActive),
                             all_right); 
                             
                            
			if((direction_CMW.number == 0) && (mode_CMW.number == 2) && dpExists("_"+PollGroupName_CMW.text+ ".PollInterval"))
				{
				int temp_interval;
				dpGet("_"+PollGroupName_CMW.text+ ".PollInterval",temp_interval );
					dpSetWait(dpe + ":_address.._interval", temp_interval,
										dpe + ":_address.._poll_group","_"+PollGroupName_CMW.text);
				}
				else
				{
					dpSetWait(dpe + ":_address.._interval", 0,
										dpe + ":_address.._poll_group","");
				}                             
      break; 
    
    default: break;
  }
}

//////////////////////////////////////////////////////////////////////////////
upWritePanelAllAddressAttributes(string dpe, int Id, anytype dpc)
{
bool bLowlevel;
bool bActive;

  switch (globalAddressOld[Id])  
  {  
    // CMWClient Driver
    case fwPeriphAddress_TYPE_CMW: 
//    DebugN("getTransformation",dpc);
		fwPeriphAddressCMW_getTransformation(dpc[3],dpc[7], dpe);
		bActive=dpc[12];	
		activeCheckButton_CMW.state(0) = bActive;

//		dpGet(dpe+":_address.._lowlevel",bLowlevel);	
//			lowlevel_CMW.state(0)=bLowlevel;
			lowlevel_CMW.state(0)=dpc[4];
		setMultiValue("referenceField_CMW","text",dpc[1],   
                    "subIndex_CMW","text",dpc[2],   
                    "driverNumberSelector_CMW","text",dpc[9]);//,
    break; 
    
    default: 
    break;
  }
}

//////////////////////////////////////////////////////////////////////////////
upReadPanelAllAddressAttributes(string dpe, int Id, dyn_anytype &dpc, bool &readOK)  
{  
  int        driver,subidx,iMode; 
  string     sRef;  
  bool bLowlevel;
  
  readOK=true;
  switch (globalAddressOld[Id])  
  {  
    // CMWClient Driver
    case fwPeriphAddress_TYPE_CMW:
		getMultiValue("referenceField_CMW","text",sRef,   
                    "subIndex_CMW","text",subidx,   
                    "driverNumberSelector_CMW","text",driver);
//		bLowlevel=lowlevel_CMW.state(0);

//		dpSetWait(dpe+":_address.._mode",iMode);
		
		dpc[1]=sRef;
	  dpc[2]=subidx;  
		dpc[8]=globalAddressDrivers[dynContains(globalAddressTypes,globalAddressNew[paMyModuleId()])]; 
		dpc[9]=driver;  
    break; 
    default: break;
  }
}
